package com.qmth.sop.business.bean;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.qmth.sop.business.bean.result.FlowFormWidgetResult;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.List;

@JsonInclude(JsonInclude.Include.NON_NULL)
public class FormPropertyBean implements Serializable {

    @ApiModelProperty(value = "流程名称")
    String flowName;

    @ApiModelProperty(value = "流程id")
    String flowId;

    @ApiModelProperty(value = "sopid")
    String sopId;

    @ApiModelProperty(value = "流程任务id")
    String taskId;

    @ApiModelProperty(value = "用户id")
    String userId;

    @ApiModelProperty(value = "taskKey")
    String taskDefinitionKey;

    @ApiModelProperty(value = "动态表单")
    List<FlowFormWidgetResult> formProperty;

    public FormPropertyBean() {

    }

    public FormPropertyBean(String flowId, String taskId, List<FlowFormWidgetResult> formProperty) {
        this.flowId = flowId;
        this.taskId = taskId;
        this.formProperty = formProperty;
    }

    public FormPropertyBean(String flowId, String taskId, String userId, List<FlowFormWidgetResult> formProperty) {
        this.flowId = flowId;
        this.taskId = taskId;
        this.userId = userId;
        this.formProperty = formProperty;
    }

    public String getFlowName() {
        return flowName;
    }

    public void setFlowName(String flowName) {
        this.flowName = flowName;
    }

    public String getSopId() {
        return sopId;
    }

    public void setSopId(String sopId) {
        this.sopId = sopId;
    }

    public String getTaskDefinitionKey() {
        return taskDefinitionKey;
    }

    public void setTaskDefinitionKey(String taskDefinitionKey) {
        this.taskDefinitionKey = taskDefinitionKey;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getFlowId() {
        return flowId;
    }

    public void setFlowId(String flowId) {
        this.flowId = flowId;
    }

    public String getTaskId() {
        return taskId;
    }

    public void setTaskId(String taskId) {
        this.taskId = taskId;
    }

    public List<FlowFormWidgetResult> getFormProperty() {
        return formProperty;
    }

    public void setFormProperty(List<FlowFormWidgetResult> formProperty) {
        this.formProperty = formProperty;
    }
}
